#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>

#include "Tree.h"
#include "AVL.h"


//Creates a random tree with 5 to 8 nodes
//and random content in each node
/*void treeGenerator(NodePointer *tree)
{
    int nNodes;
    DataStruct data;
    char dataName[10], intString[4];
    nNodes = rand()%4+5;
    for(int i = 0; i < nNodes; ++i)
    {
        sprintf(intString, "%d", i);
        data.key = i;
        data.value = rand()/(float)(RAND_MAX/10);
        strcpy(dataName, "Nó ");
        strcat(dataName, intString);
        data.name = (char*) malloc(sizeof(char)*strlen(dataName));
        strcpy(data.name, dataName);
        insert(tree, data);
    }
}*/
/* Driver program to test above function*/
int main()
{
NodePointer root = NULL;

/* Constructing tree given in the above figure */
	root = insert(root, 9);
    printf("\n\n");
    print2D(root);
	root = insert(root, 5);
    printf("\n\n");
    print2D(root);
	root = insert(root, 10);
    printf("\n\n");
    print2D(root);
	root = insert(root, 0);
    printf("\n\n");
    print2D(root);
	root = insert(root, 6);
    printf("\n\n");
    print2D(root);
	root = insert(root, 11);
    printf("\n\n");
    print2D(root);
	root = insert(root, -1);
    printf("\n\n");
    print2D(root);
	root = insert(root, 1);
    printf("\n\n");
    print2D(root);
	root = insert(root, 2);

	/* The constructed AVL Tree would be
			9
		/ \
		1 10
		/ \	 \
	0 5	 11
	/ / \
	-1 2 6
	*/

	/*printf("Preorder traversal of the constructed AVL "
		"tree is \n");
	preOrderTreeVisit(root);*/
    printf("\n\n");
    print2D(root);

	root = deleteNode(root, 10);

	/* The AVL Tree after deletion of 10
			1
		/ \
		0 9
		/	 / \
	-1 5	 11
		/ \
		2 6
	*/

	/*printf("\nPreorder traversal after deletion of 10 \n");
	preOrderTreeVisit(root);*/

    printf("\n\n");
    print2D(root);

	return 0;
}
/*
//Create a random tree, print it, than print in order
//Print it again, and then pre order
//Print it again, and then post order
int main()
{
    NodePointer tree = NULL;
    srand(time(NULL));
    treeGenerator(&tree);

    print2D(tree);
    printf("\n\n");
    printf("In Order: \n");
    inOrder(tree);
    printf("\n\n");
    print2D(tree);
    printf("\n\n");
    printf("Pre Order: \n");
    preOrder(tree);
    printf("\n\n");
    print2D(tree);
    printf("\n\n");
    printf("Post Order: \n");
    postOrder(tree);
    printf("\n\n");
    return 0;
}
*/
